Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.io
Class ObjectInputStream

    java.lang.Object
      |
      +--java.io.InputStream
            |
            +--java.io.ObjectInputStream

All Implemented Interfaces:
  DataInput, ObjectInput, ObjectStreamConstants

public class ObjectInputStream
extends InputStream
implements ObjectInput, ObjectStreamConstants

An ObjectInputStream deserializes primitive data and objects previously written using an ObjectOutputStream. ObjectOutputStream and ObjectInputStream can provide an application with persistent storage for graphs of objects when used with a FileOutputStream and FileInputStream respectively. ObjectInputStream is used to recover those objects previously serialized. Other uses include passing objects between hosts using a socket stream or for marshaling and unmarshaling arguments and parameters in a remote communication system.

ObjectInputStream ensures that the types of all objects in the graph created from the stream match the classes present in the Java Virtual Machine. Classes are loaded as required using the standard mechanisms.

Only objects that support the java.io.Serializable or java.io.Externalizable interface can be read from streams. The method readObject is used to read an object from the stream. Java's safe casting should be used to get the desired type. In Java, strings and arrays are objects and are treated as objects during serialization. When read they need to be cast to the expected type.

Primitive data types can be read from the stream using the appropriate method on DataInput.

The default deserialization mechanism for objects restores the contents of each field to the value and type it had when it was written. Fields declared as transient or static are ignored by the deserialization process. References to other objects cause those objects to be read from the stream as necessary. Graphs of objects are restored correctly using a reference sharing mechanism. New objects are always allocated when deserializing, which prevents existing objects from being overwritten.

Reading an object is analogous to running the constructors of a new object. Memory is allocated for the object and initialized to zero (NULL). No-arg constructors are invoked for the non-serializable classes and then the fields of the serializable classes are restored from the stream starting with the serializable class closest to java.lang.object and finishing with the object's most specifiec class.

For example to read from a stream as written by the example in ObjectOutputStream:

    	FileInputStream istream = new FileInputStream("t.tmp");
    	ObjectInputStream p = new ObjectInputStream(istream);

    	int i = p.readInt();
    	String today = (String)p.readObject();
    	Date date = (Date)p.readObject();

    	istream.close();

Classes control how they are serialized by implementing either the java.io.Serializable or java.io.Externalizable interfaces.

Implementing the Serializable interface allows object serialization to save and restore the entire state of the object and it allows classes to evolve between the time the stream is written and the time it is read. It automatically traverses references between objects, saving and restoring entire graphs. Serializable classes that require special handling during the serialization and deserialization process should implement both of these methods:

     private void writeObject(java.io.ObjectOutputStream stream)
         throws IOException;
     private void readObject(java.io.ObjectInputStream stream)
         throws IOException, ClassNotFoundException;

The readObject method is responsible for reading and restoring the state of the object for its particular class using data written to the stream by the corresponding writeObject method. The method does not need to concern itself with the state belonging to its superclasses or subclasses. State is restored by reading data from the ObjectInputStream for the individual fields and making assignments to the appropriate fields of the object. Reading primitive data types is supported by DataInput.

Serialization does not read or assign values to the fields of any object that does not implement the java.io.Serializable interface. Subclasses of Objects that are not serializable can be serializable. In this case the non-serializable class must have a no-arg constructor to allow its fields to be initialized. In this case it is the responsibility of the subclass to save and restore the state of the non-serializable class. It is frequently the case that the fields of that class are accessible (public, package, or protected) or that there are get and set methods that can be used to restore the state.

Any exception that occurs while deserializing an object will be caught by the ObjectInputStream and abort the reading process.

Implementing the Externalizable interface allows the object to assume complete control over the contents and format of the object's serialized form. The methods of the Externalizable interface, writeExternal and readExternal, are called to save and restore the objects state. When implemented by a class they can write and read their own state using all of the methods of ObjectOutput and ObjectInput. It is the responsibility of the objects to handle any versioning that occurs.

Since:
  JDK1.1
See Also:
  `DataInput`, `ObjectOutputStream`, `Serializable`, Object Serialization Specification, Section 3, Object Input Classes

Inner Class Summary
`static class` | `ObjectInputStream.GetField` Provide access to the persistent fields read from the input stream.

Fields inherited from interface java.io.ObjectStreamConstants
`baseWireHandle, PROTOCOL_VERSION_1, PROTOCOL_VERSION_2, SC_BLOCK_DATA, SC_EXTERNALIZABLE, SC_SERIALIZABLE, SC_WRITE_METHOD, STREAM_MAGIC, STREAM_VERSION, SUBCLASS_IMPLEMENTATION_PERMISSION, SUBSTITUTION_PERMISSION, TC_ARRAY, TC_BASE, TC_BLOCKDATA, TC_BLOCKDATALONG, TC_CLASS, TC_CLASSDESC, TC_ENDBLOCKDATA, TC_EXCEPTION, TC_LONGSTRING, TC_MAX, TC_NULL, TC_OBJECT, TC_PROXYCLASSDESC, TC_REFERENCE, TC_RESET, TC_STRING`

Constructor Summary
`protected` | `ObjectInputStream()` Provide a way for subclasses that are completely reimplementing ObjectInputStream to not have to allocate private data just used by this implementation of ObjectInputStream.
`` | `ObjectInputStream(InputStream in)` Create an ObjectInputStream that reads from the specified InputStream.

Method Summary
`int` | `available()` Returns the number of bytes that can be read without blocking.
`void` | `close()` Closes the input stream.
`void` | `defaultReadObject()` Read the non-static and non-transient fields of the current class from this stream.
`protected boolean` | `enableResolveObject(boolean enable)` Enable the stream to allow objects read from the stream to be replaced.
`int` | `read()` Reads a byte of data.
`int` | `read(byte[] b, int off, int len)` Reads into an array of bytes.
`boolean` | `readBoolean()` Reads in a boolean.
`byte` | `readByte()` Reads an 8 bit byte.
`char` | `readChar()` Reads a 16 bit char.
`protected ObjectStreamClass` | `readClassDescriptor()` Read a class descriptor from the serialization stream.
`double` | `readDouble()` Reads a 64 bit double.
`ObjectInputStream.GetField` | `readFields()` Reads the persistent fields from the stream and makes them available by name.
`float` | `readFloat()` Reads a 32 bit float.
`void` | `readFully(byte[] data)` Reads bytes, blocking until all bytes are read.
`void` | `readFully(byte[] data, int offset, int size)` Reads bytes, blocking until all bytes are read.
`int` | `readInt()` Reads a 32 bit int.
`String` | `readLine()` Deprecated. This method does not properly convert bytes to characters. see DataInputStream for the details and alternatives.
`long` | `readLong()` Reads a 64 bit long.
`Object` | `readObject()` Read an object from the ObjectInputStream.
`protected Object` | `readObjectOverride()` This method is called by trusted subclasses of ObjectOutputStream that constructed ObjectOutputStream using the protected no-arg constructor.
`short` | `readShort()` Reads a 16 bit short.
`protected void` | `readStreamHeader()` The readStreamHeader method is provided to allow subclasses to read and verify their own stream headers.
`int` | `readUnsignedByte()` Reads an unsigned 8 bit byte.
`int` | `readUnsignedShort()` Reads an unsigned 16 bit short.
`String` | `readUTF()` Reads a UTF format String.
`void` | `registerValidation(ObjectInputValidation obj, int prio)` Register an object to be validated before the graph is returned.
`protected Class` | `resolveClass(ObjectStreamClass v)` Load the local class equivalent of the specified stream class description.
`protected Object` | `resolveObject(Object obj)` This method will allow trusted subclasses of ObjectInputStream to substitute one object for another during deserialization.
`protected Class` | `resolveProxyClass(String[] interfaces)` Returns a proxy class that implements the interfaces named in a proxy class descriptor; subclasses may implement this method to read custom data from the stream along with the descriptors for dynamic proxy classes, allowing them to use an alternate loading mechanism for the interfaces and the proxy class.
`int` | `skipBytes(int len)` Skips bytes, block until all bytes are skipped.

Methods inherited from class java.io.InputStream
`mark, markSupported, read, reset, skip`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface java.io.ObjectInput
`read, skip`

Constructor Detail

### ObjectInputStream

    public ObjectInputStream(InputStream in)
                      throws IOException,
                             StreamCorruptedException

  Create an ObjectInputStream that reads from the specified InputStream. The stream header containing the magic number and version number are read from the stream and verified. This method will block until the corresponding ObjectOutputStream has written and flushed the header.
  Parameters:
    `in` - the underlying `InputStream` from which to read
  Throws:
    `StreamCorruptedException` - The version or magic number are incorrect.
    `IOException` - An exception occurred in the underlying stream.

### ObjectInputStream

    protected ObjectInputStream()
                         throws IOException,
                                SecurityException

  Provide a way for subclasses that are completely reimplementing ObjectInputStream to not have to allocate private data just used by this implementation of ObjectInputStream.

  If there is a security manager installed, this method first calls the security manager's `checkPermission` method with the `SerializablePermission("enableSubclassImplementation")` permission to ensure it's ok to enable subclassing.

  Throws:
    `IOException` - Thrown if not called by a subclass.
    `SecurityException` - if a security manager exists and its `checkPermission` method denies enabling subclassing.
  See Also:
    `SecurityManager.checkPermission(java.security.Permission)`, `SerializablePermission`

Method Detail

### readObject

    public final Object readObject()
                            throws OptionalDataException,
                                   ClassNotFoundException,
                                   IOException

  Read an object from the ObjectInputStream. The class of the object, the signature of the class, and the values of the non-transient and non-static fields of the class and all of its supertypes are read. Default deserializing for a class can be overriden using the writeObject and readObject methods. Objects referenced by this object are read transitively so that a complete equivalent graph of objects is reconstructed by readObject.

  The root object is completly restored when all of its fields and the objects it references are completely restored. At this point the object validation callbacks are executed in order based on their registered priorities. The callbacks are registered by objects (in the readObject special methods) as they are individually restored. Exceptions are thrown for problems with the InputStream and for classes that should not be deserialized. All exceptions are fatal to the InputStream and leave it in an indeterminate state; it is up to the caller to ignore or recover the stream state.

  Specified by:
    `readObject` in interface `ObjectInput`
  Throws:
    `ClassNotFoundException` - Class of a serialized object cannot be found.
    `InvalidClassException` - Something is wrong with a class used by serialization.
    `StreamCorruptedException` - Control information in the stream is inconsistent.
    `OptionalDataException` - Primitive data was found in the stream instead of objects.
    `IOException` - Any of the usual Input/Output related exceptions.

### readObjectOverride

    protected Object readObjectOverride()
                                 throws OptionalDataException,
                                        ClassNotFoundException,
                                        IOException

  This method is called by trusted subclasses of ObjectOutputStream that constructed ObjectOutputStream using the protected no-arg constructor. The subclass is expected to provide an override method with the modifier "final".
  Returns:
    the Object read from the stream.
  Throws:
    `ClassNotFoundException` - Class definition of a serialized object cannot be found.
    `OptionalDataException` - Primitive data was found in the stream instead of objects.
    `IOException` - if I/O errors occurred while reading from the underlying stream
  Since:
    1.2
  See Also:
    `ObjectInputStream()`, `readObject()`

### defaultReadObject

    public void defaultReadObject()
                           throws IOException,
                                  ClassNotFoundException,
                                  NotActiveException

  Read the non-static and non-transient fields of the current class from this stream. This may only be called from the readObject method of the class being deserialized. It will throw the NotActiveException if it is called otherwise.
  Throws:
    `ClassNotFoundException` - if the class of a serialized object could not be found.
    `IOException` - if an I/O error occurs.
    `NotActiveException` - if the stream is not currently reading objects.

### readFields

    public ObjectInputStream.GetField readFields()
                                          throws IOException,
                                                 ClassNotFoundException,
                                                 NotActiveException

  Reads the persistent fields from the stream and makes them available by name.
  Returns:
    the `GetField` object representing the persistent fields of the object being deserialized
  Throws:
    `ClassNotFoundException` - if the class of a serialized object could not be found.
    `IOException` - if an I/O error occurs.
    `NotActiveException` - if the stream is not currently reading objects.
  Since:
    1.2

### registerValidation

    public void registerValidation(ObjectInputValidation obj,
                                   int prio)
                            throws NotActiveException,
                                   InvalidObjectException

  Register an object to be validated before the graph is returned. While similar to resolveObject these validations are called after the entire graph has been reconstituted. Typically, a readObject method will register the object with the stream so that when all of the objects are restored a final set of validations can be performed.
  Parameters:
    `obj` - the object to receive the validation callback.
    `prio` - controls the order of callbacks;zero is a good default. Use higher numbers to be called back earlier, lower numbers for later callbacks. Within a priority, callbacks are processed in no particular order.
  Throws:
    `NotActiveException` - The stream is not currently reading objects so it is invalid to register a callback.
    `InvalidObjectException` - The validation object is null.

### resolveClass

    protected Class resolveClass(ObjectStreamClass v)
                          throws IOException,
                                 ClassNotFoundException

  Load the local class equivalent of the specified stream class description. Subclasses may implement this method to allow classes to be fetched from an alternate source. The corresponding method in ObjectOutputStream is annotateClass. This method will be invoked only once for each unique class in the stream. This method can be implemented by subclasses to use an alternate loading mechanism but must return a Class object. Once returned, the serialVersionUID of the class is compared to the serialVersionUID of the serialized class. If there is a mismatch, the deserialization fails and an exception is raised.

  By default the class name is resolved relative to the class that called readObject.

  Parameters:
    `v` - an instance of class ObjectStreamClass
  Returns:
    a Class object corresponding to `v`
  Throws:
    `IOException` - Any of the usual Input/Output exceptions.
    `ClassNotFoundException` - If class of a serialized object cannot be found.

### resolveProxyClass

    protected Class resolveProxyClass(String[] interfaces)
                               throws IOException,
                                      ClassNotFoundException

  Returns a proxy class that implements the interfaces named in a proxy class descriptor; subclasses may implement this method to read custom data from the stream along with the descriptors for dynamic proxy classes, allowing them to use an alternate loading mechanism for the interfaces and the proxy class.

  This method is called exactly once for each unique proxy class descriptor in the stream.

  The corresponding method in `ObjectOutputStream` is `annotateProxyClass`. For a given subclass of `ObjectInputStream` that overrides this method, the `annotateProxyClass` method in the corresponding subclass of `ObjectOutputStream` must write any data or objects read by this method.

  The default implementation of this method in `ObjectInputStream` returns the result of calling `Proxy.getProxyClass` with the list of `Class` objects for the interfaces that are named in the `interfaces` parameter. The `Class` object for each interface name `i` is the value returned by calling

           Class.forName(i, false, loader)

  where `loader` is that of the first non-null class loader up the execution stack, or `null` if no non-null class loaders are on the stack (the same class loader choice used by the `resolveClass` method). This same value of `loader` is also the class loader passed to `Proxy.getProxyClass`. If `Proxy.getProxyClass` throws an `IllegalArgumentException`, `resolveProxyClass` will throw a `ClassNotFoundException` containing the `IllegalArgumentException`.
  Parameters:
    `interfaces` - the list of interface names that were deserialized in the proxy class descriptor
  Returns:
    a proxy class for the specified interfaces
  Throws:
    `IOException` - any exception thrown by the underlying `InputStream`
    `ClassNotFoundException` - if the proxy class or any of the named interfaces could not be found
  Since:
    1.3
  See Also:
    `ObjectOutputStream.annotateProxyClass(Class)`

### resolveObject

    protected Object resolveObject(Object obj)
                            throws IOException

  This method will allow trusted subclasses of ObjectInputStream to substitute one object for another during deserialization. Replacing objects is disabled until enableResolveObject is called. The enableResolveObject method checks that the stream requesting to resolve object can be trusted. Every reference to serializable objects is passed to resolveObject. To insure that the private state of objects is not unintentionally exposed only trusted streams may use resolveObject.

  This method is called after an object has been read but before it is returned from readObject. The default resolveObject method just returns the same object.

  When a subclass is replacing objects it must insure that the substituted object is compatible with every field where the reference will be stored. Objects whose type is not a subclass of the type of the field or array element abort the serialization by raising an exception and the object is not be stored.

  This method is called only once when each object is first encountered. All subsequent references to the object will be redirected to the new object.

  Parameters:
    `obj` - object to be substituted
  Returns:
    the substituted object
  Throws:
    `IOException` - Any of the usual Input/Output exceptions.

### enableResolveObject

    protected boolean enableResolveObject(boolean enable)
                                   throws SecurityException

  Enable the stream to allow objects read from the stream to be replaced. When enabled, the resolveObject method is called for every object being deserialized. If enable is true, and there is a security manager installed, this method first calls the security manager's `checkPermission` method with the `SerializablePermission("enableSubstitution")` permission to ensure it's ok to enable the stream to allow objects read from the stream to be replaced.
  Parameters:
    `enable` - true for enabling use of `resolveObject` for every object being deserialized
  Returns:
    the previous setting before this method was invoked
  Throws:
    `SecurityException` - if a security manager exists and its `checkPermission` method denies enabling the stream to allow objects read from the stream to be replaced.
  See Also:
    `SecurityManager.checkPermission(java.security.Permission)`, `SerializablePermission`

### readStreamHeader

    protected void readStreamHeader()
                             throws IOException,
                                    StreamCorruptedException

  The readStreamHeader method is provided to allow subclasses to read and verify their own stream headers. It reads and verifies the magic number and version number.
  Throws:
    `IOException` - if there are I/O errors while reading from the underlying `InputStream`
    `StreamCorruptedException` - if control information in the stream is inconsistent

### readClassDescriptor

    protected ObjectStreamClass readClassDescriptor()
                                             throws IOException,
                                                    ClassNotFoundException

  Read a class descriptor from the serialization stream. This method is called when the ObjectInputStream expects a class descriptor as the next item in the serialization stream. Subclasses of ObjectInputStream may override this method to read in class descriptors that have been written in non-standard formats (by subclasses of ObjectOutputStream which have overridden the `writeClassDescriptor` method). By default, this method reads class descriptors according to the format defined in the Object Serialization specification.

  Returns:
    the class descriptor read
  Throws:
    `IOException` - If an I/O error has occurred.
    `ClassNotFoundException` - If the Class of a serialized object used in the class descriptor representation cannot be found
  Since:
    1.3
  See Also:
    `ObjectOutputStream.writeClassDescriptor(java.io.ObjectStreamClass)`

### read

    public int read()
             throws IOException

  Reads a byte of data. This method will block if no input is available.
  Specified by:
    `read` in interface `ObjectInput`
  Overrides:
    `read` in class `InputStream`
  Returns:
    the byte read, or -1 if the end of the stream is reached.
  Throws:
    `IOException` - If an I/O error has occurred.

### read

    public int read(byte[] b,
                    int off,
                    int len)
             throws IOException

  Reads into an array of bytes. This method will block until some input is available. Consider using java.io.DataInputStream.readFully to read exactly 'length' bytes.
  Specified by:
    `read` in interface `ObjectInput`
  Overrides:
    `read` in class `InputStream`
  Parameters:
    `b` - the buffer into which the data is read
    `off` - the start offset of the data
    `len` - the maximum number of bytes read
  Returns:
    the actual number of bytes read, -1 is returned when the end of the stream is reached.
  Throws:
    `IOException` - If an I/O error has occurred.
  See Also:
    `DataInputStream.readFully(byte[],int,int)`

### available

    public int available()
                  throws IOException

  Returns the number of bytes that can be read without blocking.
  Specified by:
    `available` in interface `ObjectInput`
  Overrides:
    `available` in class `InputStream`
  Returns:
    the number of available bytes.
  Throws:
    `IOException` - if there are I/O errors while reading from the underlying `InputStream`

### close

    public void close()
               throws IOException

  Closes the input stream. Must be called to release any resources associated with the stream.
  Specified by:
    `close` in interface `ObjectInput`
  Overrides:
    `close` in class `InputStream`
  Throws:
    `IOException` - If an I/O error has occurred.

### readBoolean

    public boolean readBoolean()
                        throws IOException

  Reads in a boolean.
  Specified by:
    `readBoolean` in interface `DataInput`
  Returns:
    the boolean read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readByte

    public byte readByte()
                  throws IOException

  Reads an 8 bit byte.
  Specified by:
    `readByte` in interface `DataInput`
  Returns:
    the 8 bit byte read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readUnsignedByte

    public int readUnsignedByte()
                         throws IOException

  Reads an unsigned 8 bit byte.
  Specified by:
    `readUnsignedByte` in interface `DataInput`
  Returns:
    the 8 bit byte read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readShort

    public short readShort()
                    throws IOException

  Reads a 16 bit short.
  Specified by:
    `readShort` in interface `DataInput`
  Returns:
    the 16 bit short read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readUnsignedShort

    public int readUnsignedShort()
                          throws IOException

  Reads an unsigned 16 bit short.
  Specified by:
    `readUnsignedShort` in interface `DataInput`
  Returns:
    the 16 bit short read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readChar

    public char readChar()
                  throws IOException

  Reads a 16 bit char.
  Specified by:
    `readChar` in interface `DataInput`
  Returns:
    the 16 bit char read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readInt

    public int readInt()
                throws IOException

  Reads a 32 bit int.
  Specified by:
    `readInt` in interface `DataInput`
  Returns:
    the 32 bit integer read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readLong

    public long readLong()
                  throws IOException

  Reads a 64 bit long.
  Specified by:
    `readLong` in interface `DataInput`
  Returns:
    the read 64 bit long.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readFloat

    public float readFloat()
                    throws IOException

  Reads a 32 bit float.
  Specified by:
    `readFloat` in interface `DataInput`
  Returns:
    the 32 bit float read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readDouble

    public double readDouble()
                      throws IOException

  Reads a 64 bit double.
  Specified by:
    `readDouble` in interface `DataInput`
  Returns:
    the 64 bit double read.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readFully

    public void readFully(byte[] data)
                   throws IOException

  Reads bytes, blocking until all bytes are read.
  Specified by:
    `readFully` in interface `DataInput`
  Parameters:
    `data` - the buffer into which the data is read
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readFully

    public void readFully(byte[] data,
                          int offset,
                          int size)
                   throws IOException

  Reads bytes, blocking until all bytes are read.
  Specified by:
    `readFully` in interface `DataInput`
  Parameters:
    `data` - the buffer into which the data is read
    `offset` - the start offset of the data
    `size` - the maximum number of bytes to read
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### skipBytes

    public int skipBytes(int len)
                  throws IOException

  Skips bytes, block until all bytes are skipped.
  Specified by:
    `skipBytes` in interface `DataInput`
  Parameters:
    `len` - the number of bytes to be skipped
  Returns:
    the actual number of bytes skipped.
  Throws:
    `EOFException` - If end of file is reached.
    `IOException` - If other I/O error has occurred.

### readLine

    public String readLine()
                    throws IOException

  Deprecated. This method does not properly convert bytes to characters. see DataInputStream for the details and alternatives.

  Reads in a line that has been terminated by a \n, \r, \r\n or EOF.
  Specified by:
    `readLine` in interface `DataInput`
  Returns:
    a String copy of the line.
  Throws:
    `IOException` - if there are I/O errors while reading from the underlying `InputStream`

### readUTF

    public String readUTF()
                   throws IOException

  Reads a UTF format String.
  Specified by:
    `readUTF` in interface `DataInput`
  Returns:
    the String.
  Throws:
    `IOException` - if there are I/O errors while reading from the underlying `InputStream`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.